/* 
 * File:   main.c
 * Author: Bugz Bensce
 *
 * Created on 15 March 2023, 2:50 PM
 */

#define  _XTAL_FREQ  8000000
#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "assets/config/config_words.h"
#include "assets/Segments/Segments.h"
#include "assets/DS18B20/DS18B20.h"
//------------------------------------------------------------------------------
int main(int argc, char** argv) 
{
  OSCCON =  0x70;       // set internal oscillator to 8MHz
  ANSELH = 0;           // configure all PORTB pins as digital

  Segments_init();
  
  while(1)
  {    
    signed int rawTemp = 0;
    
    if(ds18b20_read(&rawTemp))
    {
       signed int tempr = (signed int) (ds18b20_toFloat(rawTemp) * 10);
       Segments_display( FIFO, tempr );
    }
  }

  return (EXIT_SUCCESS);
}
//------------------------------------------------------------------------------